;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Author :  Amando Abreu(and anyone who has ever used PICs)                         ;
; Date :  24/7/2010                                                                 ;
; Version: 1.0                                                                      ;
; Title: LED chaser                                                                 ;
; PIC: 16F628                                                                       ;
; Description: Chases LEDs on pins RB0 to RB7 with a 50ms delay betwen each LED.    ;
; PIC is wired "barebones" and all LEDs have a current limiting resistor.           ;
; Feel free to modify this ASM file.                                                ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;*****Set up the Constants**** 

LIST P=16F628, R=DEC    ; Use the PIC16F628 and decimal system

#include "P16F628.INC"  ; Include header file

__config  _INTRC_OSC_NOCLKOUT & _LVP_OFF & _WDT_OFF & _PWRTE_ON & _BODEN_ON

CBLOCK 0x20             ; Declare variable addresses starting at 0x20 
COUNT1,COUNT2 
ENDC 

;****Set up the port**** 

BSF              STATUS,RP0       ;Switch to Bank 1
MOVLW            00h              ;Set the Port A pins
MOVWF            TRISB            ;to output.
BCF              STATUS,RP0       ;Switch back to Bank 0 

;****Main**** 

Start               
RRF  PORTB           ;rotate PORTB right pg 120 of datasheet
CALL delay
GOTO  Start          ;Back to start

;****50ms delay****

delay MOVLW 50
      MOVWF COUNT1
Outer MOVLW 200
      MOVWF COUNT2
Inner NOP
      NOP
      DECFSZ COUNT2,F
      GOTO Inner ; Inner Loop = 5uS
      DECFSZ COUNT1,F
      GOTO Outer
      RETURN
END    